Index: edit_forum_preferences_form.php
===================================================================
--- edit_forum_preferences_form.php	(Revision 24007)
+++ edit_forum_preferences_form.php	(Arbeitskopie)
@@ -28,7 +28,7 @@
 $user = get_logged_in_user();
 BoincForumPrefs::lookup($user);
 
-page_head("Community preferences");
+page_head(tra("Community preferences"));
 
 // output a script for counting chars left in text field
 //
@@ -48,15 +48,15 @@
 
 // ------------ Notification -----------
 
-row1("Notifications");
+row1(tra("Notifications"));
 $ch0 = $user->prefs->pm_notification==0?"checked":"";
 $ch1 = $user->prefs->pm_notification==1?"checked":"";
 $ch2 = $user->prefs->pm_notification==2?"checked":"";
 row2(
-    "How should we notify you of new private messages, friend requests, posts in subscribed threads, and other events?",
-    "<input type=radio name=pm_notification value=0 $ch0> On my Account page (no email)
-    <br><input type=radio name=pm_notification value=1 $ch1> Immediately, by email
-    <br><input type=radio name=pm_notification value=2 $ch2> In a single daily email
+    tra("How should we notify you of new private messages, friend requests, posts in subscribed threads, and other events?"),
+    "<input type=radio name=pm_notification value=0 $ch0> ".tra("On my Account page (no email)")."
+    <br><input type=radio name=pm_notification value=1 $ch1> ".tra("Immediately, by email")."
+    <br><input type=radio name=pm_notification value=2 $ch2> ".tra("In a single daily email")."
     "
 );
 
@@ -72,112 +72,81 @@
 } else {
     $select_0 = "checked=\"true\"";
 }
-row1("Message-board identity");
-row2("Avatar
-    <br><span class=\"note\">An image representing you on the message boards.
-    <br>Format: JPG or PNG. Size: at most 4 KB, 100x100 pixels</span>",
+row1(tra("Message-board identity"));
+row2(tra("Avatar")."
+    <br><span class=\"note\">".tra("An image representing you on the message boards.")."
+    <br>".tra("Format: JPG or PNG. Size: at most 4 KB, 100x100 pixels")."</span>",
     "<input type=\"radio\" id=\"avatar_select_0\" name=\"avatar_select\" value=\"0\" ".$select_0.">
-        <label for=\"avatar_select_0\">Don't use an avatar</label><br>
+        <label for=\"avatar_select_0\">".tra("Don't use an avatar")."</label><br>
     <input type=\"radio\" id=\"avatar_select_1\" name=\"avatar_select\" value=\"1\" ".$select_1.">
-        <label for=\"avatar_select_1\">Use a Globally Recognized Avatar provided by <a href=\"http://gravatar.com\">Gravatar.com</a></label><br>
+        <label for=\"avatar_select_1\">".tra("Use a Globally Recognized Avatar provided by %1", "<a href=\"http://gravatar.com\">Gravatar.com</a>")."</label><br>
     <input type=\"radio\" id=\"avatar_select_2\" name=\"avatar_select\" value=\"2\" ".$select_2.">
-        <label for=\"avatar_select_2\">Use this uploaded avatar:</label> <input type=\"file\" name=\"picture\">"
+        <label for=\"avatar_select_2\">".tra("Use this uploaded avatar:")."</label> <input type=\"file\" name=\"picture\">"
 );
 if (strlen($user->prefs->avatar)){
-    row2("Avatar preview<br><span class=\"note\">This is how your avatar will look</span>",
+    row2(tra("Avatar preview")."<br><span class=\"note\">".tra("This is how your avatar will look")."</span>",
     "<img src=\"".$user->prefs->avatar."\" width=\"100\" height=\"100\">");
 }
 
-if (!$user->prefs->no_signature_by_default){
-    $signature_by_default="checked=\"checked\"";
-} else {
-    $signature_by_default="";
-}
+$signature_by_default = $user->prefs->no_signature_by_default==false?"checked=\"checked\"":"";
+
 $signature=$user->prefs->signature;
 $maxlen=250;
 row2(
-    "Signature for message board posts"
+    tra("Signature for message board posts")
     .html_info()
-    ."<br><br>Check out <a href=http://boinc.berkeley.edu/links.php#sigs>various free services</a>
-    <br> providing dynamic 'signature images'
-    <br> showing your latest credit info, project news, etc.",
+    ."<br><br>"
+    .tra("Check out %1various free services%2
+<br> providing dynamic 'signature images'
+<br> showing your latest credit info, project news, etc.", "<a href=http://boinc.berkeley.edu/links.php#sigs>", "</a>"),
     "<textarea name=\"signature\" rows=4 cols=50 id=\"signature\" onkeydown=\"textCounter(this.form.signature, this.form.remLen,$maxlen);\"
     onkeyup=\"textCounter(this.form.signature, this.form.remLen,250);\">".$signature."</textarea>
-    <br><input name=\"remLen\" type=\"text\" id=\"remLen\" value=\"".($maxlen-strlen($signature))."\" size=\"3\" maxlength=\"3\" readonly> chars remaining
-    <br><input type=\"checkbox\" name=\"signature_by_default\" ".$signature_by_default."> Attach signature by default "
+    <br><input name=\"remLen\" type=\"text\" id=\"remLen\" value=\"".($maxlen-strlen($signature))."\" size=\"3\" maxlength=\"3\" readonly> ".tra("characters remaining")."
+    <br><input type=\"checkbox\" name=\"signature_by_default\" ".$signature_by_default."> ".tra("Attach signature by default")
 );
 if ($user->prefs->signature!=""){
-    row2("Signature preview".
-        "<br><span class=note>This is how your signature will look in the forums</span>",
+    row2(tra("Signature preview").
+        "<br><span class=note>".tra("This is how your signature will look in the forums")."</span>",
         output_transform($user->prefs->signature)
     );
 }
 
 // ------------ Message display  -----------
 
-if ($user->prefs->hide_avatars){
-    $forum_hide_avatars = "checked=\"checked\"";
-} else {
-    $forum_hide_avatars = "";
-}
-if ($user->prefs->hide_signatures){
-    $forum_hide_signatures = "checked=\"checked\"";
-} else {
-    $forum_hide_signatures = "";
-}
+$forum_hide_avatars = $user->prefs->hide_avatars?"checked=\"checked\"":"";
+$forum_hide_signatures = $user->prefs->hide_signatures?"checked=\"checked\"":"";
+$forum_link_popup = $user->prefs->link_popup?"checked=\"checked\"":""; 
+$forum_image_as_link = $user->prefs->images_as_links?"checked=\"checked\"":"";
+$forum_jump_to_unread = $user->prefs->jump_to_unread?"checked=\"checked\"":"";
+$forum_ignore_sticky_posts = $user->prefs->ignore_sticky_posts?"checked=\"checked\"":"";
+$forum_highlight_special = $user->prefs->highlight_special?"checked=\"checked\"":"";
 
-if ($user->prefs->link_popup){
-    $forum_link_popup="checked=\"checked\"";
-} else {
-    $forum_link_popup="";
-}
-if ($user->prefs->images_as_links){
-    $forum_image_as_link="checked=\"checked\"";
-} else {
-    $forum_image_as_link="";
-}
-if ($user->prefs->jump_to_unread){
-    $forum_jump_to_unread="checked=\"checked\"";
-} else {
-    $forum_jump_to_unread="";
-}
-if ($user->prefs->ignore_sticky_posts){
-    $forum_ignore_sticky_posts="checked=\"checked\"";
-} else {
-    $forum_ignore_sticky_posts="";
-}
-if ($user->prefs->highlight_special){
-    $forum_highlight_special="checked=\"checked\"";
-} else {
-    $forum_highlight_special="";
-}
-
 $forum_minimum_wrap_postcount = intval($user->prefs->minimum_wrap_postcount);
 $forum_display_wrap_postcount = intval($user->prefs->display_wrap_postcount);
 
-row1("Message display");
+row1(tra("Message display"));
 row2(
-    "What to display",
-    "<input type=\"checkbox\" name=\"forum_hide_avatars\" ".$forum_hide_avatars."> Hide avatar images<br>
-    <input type=\"checkbox\" name=\"forum_hide_signatures\" ".$forum_hide_signatures."> Hide signatures<br>
-    <input type=\"checkbox\" name=\"forum_images_as_links\" ".$forum_image_as_link."> Show images as links<br>
-    <input type=\"checkbox\" name=\"forum_link_popup\" ".$forum_link_popup."> Open links in new window/tab<br>
-    <input type=\"checkbox\" name=\"forum_highlight_special\" ".$forum_highlight_special."> Highlight special users<br>
+    tra("What to display"),
+    "<input type=\"checkbox\" name=\"forum_hide_avatars\" ".$forum_hide_avatars."> ".tra("Hide avatar images")."<br>
+    <input type=\"checkbox\" name=\"forum_hide_signatures\" ".$forum_hide_signatures."> ".tra("Hide signatures")."<br>
+    <input type=\"checkbox\" name=\"forum_images_as_links\" ".$forum_image_as_link."> ".tra("Show images as links")."<br>
+    <input type=\"checkbox\" name=\"forum_link_popup\" ".$forum_link_popup."> ".tra("Open links in new window/tab")."<br>
+    <input type=\"checkbox\" name=\"forum_highlight_special\" ".$forum_highlight_special."> ".tra("Highlight special users")."<br>
     "
 );
 
-row2("How to sort",
-    "Threads: ".select_from_array("forum_sort", $forum_sort_styles, $user->prefs->forum_sorting)."<br>Posts: ".select_from_array("thread_sort", $thread_sort_styles, $user->prefs->thread_sorting)."<br>
-    <input type=\"checkbox\" name=\"forum_jump_to_unread\" ".$forum_jump_to_unread."> Jump to first new post in thread automatically<br>
-    <input type=\"checkbox\" name=\"forum_ignore_sticky_posts\" ".$forum_ignore_sticky_posts.">Do not reorder sticky posts<br>
-    <input type=\"text\" name=\"forum_minimum_wrap_postcount\" size=3 value=\"".$forum_minimum_wrap_postcount."\"> If a thread contains more than this number of posts<br />
-    <input type=\"text\" name=\"forum_display_wrap_postcount\" size=3 value=\"".$forum_display_wrap_postcount."\"> only display the first one and this many of the last ones<br />
+row2(tra("How to sort"),
+    tra("Threads:")." ".select_from_array("forum_sort", $forum_sort_styles, $user->prefs->forum_sorting)."<br>".tra("Posts:")." ".select_from_array("thread_sort", $thread_sort_styles, $user->prefs->thread_sorting)."<br>
+    <input type=\"checkbox\" name=\"forum_jump_to_unread\" ".$forum_jump_to_unread."> ".tra("Jump to first new post in thread automatically")."<br>
+    <input type=\"checkbox\" name=\"forum_ignore_sticky_posts\" ".$forum_ignore_sticky_posts.">".tra("Do not reorder sticky posts")."<br>
+    <input type=\"text\" name=\"forum_minimum_wrap_postcount\" size=3 value=\"".$forum_minimum_wrap_postcount."\"> ".tra("If a thread contains more than this number of posts")."<br />
+    <input type=\"text\" name=\"forum_display_wrap_postcount\" size=3 value=\"".$forum_display_wrap_postcount."\"> ".tra("only display the first one and this many of the last ones")."<br />
     "
 );
 
 // ------------ Message filtering  -----------
 
-row1("Message filtering");
+row1(tra("Message filtering"));
 
 $filtered_userlist = get_ignored_list($user);
 $forum_filtered_userlist = "";
@@ -189,24 +158,24 @@
             echo "Missing user $id";
             continue;
         }
-        $forum_filtered_userlist .= "<input type =\"submit\" name=\"remove".$filtered_user->id."\" value=\"Remove\"> ".$filtered_user->id." - ".user_links($filtered_user)."<br>";
+        $forum_filtered_userlist .= "<input type =\"submit\" name=\"remove".$filtered_user->id."\" value=\"".tra("Remove")."\"> ".$filtered_user->id." - ".user_links($filtered_user)."<br>";
     }
 }
 
-row2("Filtered users".
-    "<br><span class=note>Ignore message board posts and private messages from these  users.</span>",
+row2(tra("Filtered users").
+    "<br><span class=note>".tra("Ignore message board posts and private messages from these users.")."</span>",
     "$forum_filtered_userlist
-        <input type=\"text\" name=\"forum_filter_user\" size=12> User ID (For instance: 123456789)
-        <br><input type=\"submit\" name=\"add_user_to_filter\" value=\"Add user to filter\">
+        <input type=\"text\" name=\"forum_filter_user\" size=12> ".tra("User ID (For instance: 123456789)")."
+        <br><input type=\"submit\" name=\"add_user_to_filter\" value=\"".tra("Add user to filter")."\">
     "
 );
 
-row1("Update");
-row2("Click here to update preferences", "<input type=submit value=\"Update\">");
+row1(tra("Update"));
+row2(tra("Click here to update preferences"), "<input type=submit value=\"".tra("Update")."\">");
 echo "</form>\n";
-row1("Reset");
-row2("Or click here to reset preferences to the defaults",
-    "<form method=\"post\" action=\"edit_forum_preferences_action.php\"><input type=\"submit\" value=\"Reset\"><input type=\"hidden\" name=\"action\" value=\"reset_confirm\"></form>"
+row1(tra("Reset"));
+row2(tra("Or click here to reset preferences to the defaults"),
+    "<form method=\"post\" action=\"edit_forum_preferences_action.php\"><input type=\"submit\" value=\"".tra("Reset")."\"><input type=\"hidden\" name=\"action\" value=\"reset_confirm\"></form>"
 );
 end_table();
 page_tail();
Index: forum_moderate_post.php
===================================================================
--- forum_moderate_post.php	(Revision 24007)
+++ forum_moderate_post.php	(Arbeitskopie)
@@ -37,10 +37,10 @@
     error_page("No action specified");
 }
 if (!is_moderator($logged_in_user, $forum)) {
-    error_page("You are not authorized to moderate this post.");
+    error_page(tra("You are not authorized to moderate this post."));
 }    
 
-page_head('Moderate post');
+page_head(tra("Moderate post"));
 
 echo "<form action=\"forum_moderate_post_action.php?id=".$post->id."\" method=\"POST\">\n";
 echo form_tokens($logged_in_user->authenticator);
@@ -49,60 +49,56 @@
 if (get_str('action')=="hide") {
     //display input that selects reason
     echo "<input type=hidden name=action value=hide>";
-    row1("Hide post");
-    row2("Reason",
+    row1(tra("Hide post"));
+    row2(tra("Reason"),
     "<select name=\"category\">
-    <option value=\"1\">Obscene</option>
-    <option value=\"2\">Flame/Hate mail</option>
-    <option value=\"3\">Commercial spam</option>
-    <option value=\"4\">Doublepost</option>
-    <option value=\"5\">User Request</option>
-    <option value=\"6\">Other</option>
+    <option value=\"1\">".tra("Obscene")."</option>
+    <option value=\"2\">".tra("Flame/Hate mail")."</option>
+    <option value=\"3\">".tra("Commercial spam")."</option>
+    <option value=\"4\">".tra("Doublepost")."</option>
+    <option value=\"5\">".tra("User Request")."</option>
+    <option value=\"6\">".tra("Other")."</option>
 </select>");
 } elseif (get_str('action')=="move") {
-    row1("Move post");
+    row1(tra("Move post"));
     echo "<input type=hidden name=action value=move>";
-    row2("Destination thread ID:", "<input name=\"threadid\">");
-    //todo display where to move the post as a dropdown instead of having to get ID    
+    row2(tra("Destination thread ID:"), "<input name=\"threadid\">");
+    // TODO: display where to move the post as a dropdown instead of having to get ID    
 } elseif (get_str('action')=="banish_user") {
     $userid = get_int('userid');
     $user = BoincUser::lookup_id($userid);
     BoincForumPrefs::lookup($user);
     if (!$user) {
-        error_page("no user");
+        error_page("no user found");
     }
     $x = $user->prefs->banished_until;
     if ($x>time()) {
-        error_page("User is already banished");
+        error_page(tra("User is already banished"));
     }
-    row1("Banish user");
-    row1("Are you sure you want to banish ".$user->name."?
-        This will prevent ".$user->name." from posting for chosen time period.<br />
-        It should be done only if ".$user->name."
-        has consistently exhibited trollish behavior.");
-    row2("Ban duration", "<select name=\"duration\">
-            <option value=\"14400\">4 hours</option>
-            <option value=\"86400\">1 day</option>
-            <option value=\"604800\">1 week</option>
-            <option value=\"1209600\" selected=\"selected\">2 weeks</option>
-            <option value=\"2592000\">1 month</option>
-            <option value=\"-1\">Forever</option>
+    row1(tra("Banish user"));
+    row1(tra("Are you sure you want to banish %1?<br/>This will prevent %1 from posting for chosen time period.<br/>It should be done only if %1 has consistently exhibited trollish behavior.", $user->name));
+    row2(tra("Ban duration"), "<select name=\"duration\">
+            <option value=\"14400\">".tra("4 hours")."</option>
+            <option value=\"86400\">".tra("1 day")."</option>
+            <option value=\"604800\">".tra("1 week")."</option>
+            <option value=\"1209600\" selected=\"selected\">".tra("2 weeks")."</option>
+            <option value=\"2592000\">".tra("1 month")."</option>
+            <option value=\"-1\">".tra("Forever")."</option>
         </select>");
     echo "<input type=\"hidden\" name=\"action\" value=\"banish_user\">\n";
     echo "<input type=\"hidden\" name=\"id\" value=\"".$postid."\">\n";
     echo "<input type=\"hidden\" name=\"userid\" value=\"".$userid."\">\n";
     echo "<input type=\"hidden\" name=\"confirmed\" value=\"yes\">\n";
 } else {
-    error_page( "Unknown action");
+    error_page("Unknown action");
 }
 
-row2("Optional explanation
-    <br><span class=note>This is included in email to user</span>",
+row2(tra("Optional explanation %1 This is included in email to user.%2", "<br><span class=note>", "</span>"),
     "<textarea name=\"reason\" rows=\"10\" cols=\"80\"></textarea>");
 
 row2(
     "",
-    "<input type=\"submit\" name=\"submit\" value=\"OK\">"
+    "<input type=\"submit\" name=\"submit\" value=\"".tra("OK")."\">"
 );
 
 end_table();
Index: profile_menu.php
===================================================================
--- profile_menu.php	(Revision 24007)
+++ profile_menu.php	(Arbeitskopie)
@@ -50,7 +50,7 @@
         $user = lookup_user_id($profile->userid);
         echo uotd_thumbnail($profile, $user);
         echo user_links($user)."<br>";
-        echo sub_sentence(output_transform(strip_tags($profile->response1)), ' ', 150, true);
+        echo sub_sentence(output_transform(sanitize_tags($profile->response1)), ' ', 150, true);
     }
 
 echo "</td></tr>";
Index: team_edit_action.php
===================================================================
--- team_edit_action.php	(Revision 24007)
+++ team_edit_action.php	(Arbeitskopie)
@@ -27,15 +27,15 @@
 $teamid = post_int("teamid");
 $team = BoincTeam::lookup_id($teamid);
 
-if (!$team) error_page(tra("no such team"));
+if (!$team) error_page("no such team");
 require_admin($user, $team);
 
-$team_url = BoincDb::escape_string(strip_tags(post_str("url", true)));
+$team_url = BoincDb::escape_string(sanitize_tags(post_str("url", true)));
 $x = strstr($team_url, "http://");
 if ($x) {
     $team_url = substr($team_url, 7);
 }
-$team_name = BoincDb::escape_string(strip_tags(post_str("name")));
+$team_name = BoincDb::escape_string(sanitize_tags(post_str("name")));
 $team_name_lc = strtolower($team_name);
 
 $tnh = post_str("name_html", true);
@@ -50,7 +50,7 @@
     $country = "International";
 }
 if (!is_valid_country($country)) {
-    error_page(tra("bad country"));
+    error_page("bad country");
 }
 $joinable = post_str('joinable', true)?1:0;
 
